﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using Telerik.Web.UI;

public partial class Default : System.Web.UI.Page
{
	private List<DockState> CurrentDockStates
	{
		get
		{
			List<DockState> _currentDockStates = (List<DockState>)Session["CurrentDockStatesDynamicDocks"];
			if (Object.Equals(_currentDockStates, null))
			{
				_currentDockStates = new List<DockState>();
				Session["CurrentDockStatesDynamicDocks"] = _currentDockStates;
			}
			return _currentDockStates;
		}
		set
		{
			Session["CurrentDockStatesDynamicDocks"] = value;
		}
	}

	private RadDock CreateRadDockFromState(DockState state)
	{
		RadDock dock = new RadDock();
		dock.DockMode = DockMode.Docked;
		dock.ID = string.Format("RadDock{0}", state.UniqueName);
		RadButton button = new RadButton();
		button.Text = "Click";
		button.Click += new EventHandler(button_Click);
		dock.ContentContainer.Controls.Add(button);
		dock.ApplyState(state);
		
		return dock;
	}

	private RadDock CreateRadDock()
	{
		int docksCount = CurrentDockStates.Count;

		RadDock dock = new RadDock();
		dock.DockMode = DockMode.Docked;
		dock.UniqueName = Guid.NewGuid().ToString().Replace("-", "a");
		dock.ID = string.Format("RadDock{0}", dock.UniqueName);
		dock.Title = "Dock";
		dock.Text = string.Format("Added at {0}", DateTime.Now);
		dock.Width = Unit.Pixel(300);
		RadButton button = new RadButton();
		button.Text = "Click";
		button.Click += new EventHandler(button_Click);
		dock.ContentContainer.Controls.Add(button);

		return dock;
	}

	protected void button_Click(object sender, EventArgs e)
	{
		Label1.Text = "Click inside RadDock";
		Label2.Text = "Click inside RadDock";
	}

	
	protected void Page_Init(object sender, EventArgs e)
	{
		
		for (int i = 0; i < CurrentDockStates.Count; i++)
		{
			RadDock dock = CreateRadDockFromState(CurrentDockStates[i]);
			RadDockLayout1.Controls.Add(dock);
			dock.AutoPostBack = true;
		}
	}

	protected void RadDockLayout1_LoadDockLayout(object sender, DockLayoutEventArgs e)
	{
		foreach (DockState state in CurrentDockStates)
		{
			e.Positions[state.UniqueName] = state.DockZoneID;
			e.Indices[state.UniqueName] = state.Index;
		}
	}

	protected void RadDockLayout1_SaveDockLayout(object sender, DockLayoutEventArgs e)
	{
		CurrentDockStates = RadDockLayout1.GetRegisteredDocksState();
	}

	protected void ButtonAddDock_Click(object sender, EventArgs e)
	{
		RadDock dock = CreateRadDock();
		RadDockZone1.Controls.Add(dock);
		dock.AutoPostBack = true;
	}
}
